
Imports System
Imports Microsoft.DirectX
Imports Microsoft.DirectX.DirectInput
Imports Microsoft.DirectX.Direct3D


Public Class Form1
    Inherits System.Windows.Forms.Form

    Private dev As Direct3D.Device = Nothing
    Private state As JoystickState
    Private InputDev As DirectInput.Device
    Private meshPlane As BaseModel = Nothing
    Private presentParam As PresentParameters = New PresentParameters()
    Private ScreenSize As Size = New Size(640, 480)
    Private IsMouseDown As Boolean = False
    Private MousePoint As Point
    Private PixelPerRadianX, PixelPerRadianY As Single
    Private meshMaterials() As Direct3D.Material ' Materials for our mesh
    Private meshTextures() As Texture ' Textures for our mesh
    Private mesh As Mesh

    Public Sub New()
        MyBase.New()
        Me.Size = ScreenSize
        InitializeComponent()
        meshPlane = New BaseModel()
        PixelPerRadianX = ScreenSize.Width / (2 * Math.PI)
        PixelPerRadianY = ScreenSize.Height / (2 * Math.PI)
        'InitializeGraphics()
    End Sub

    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Windows tH[ fUCiŕKvłB
    Private components As System.ComponentModel.IContainer

    '  : ȉ̃vV[ẂAWindows tH[ fUCiŕKvłB
    ' Windows tH[ fUCigĕύXĂB  
    ' R[h GfB^͎gpȂłB
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        components = New System.ComponentModel.Container()
        Me.Text = "Form1"
    End Sub

    Private Function InitializeGraphics()
        presentParam.Windowed = True
        presentParam.SwapEffect = SwapEffect.Discard
        presentParam.EnableAutoDepthStencil = True
        presentParam.AutoDepthStencilFormat = DepthFormat.D16

        dev = New Direct3D.Device(0, Direct3D.DeviceType.Hardware, Me, CreateFlags.SoftwareVertexProcessing, presentParam)
        AddHandler dev.DeviceReset, AddressOf OnResetDevice
        Me.OnResetDevice(dev, Nothing)
    End Function

    Public Function InitDirectInput() As Boolean
        ' Enumerate joysticks in the system.
        Dim instance As DeviceInstance

        For Each instance In DirectInput.Manager.GetDevices(DeviceClass.GameControl, EnumDevicesFlags.AttachedOnly)
            ' Create the device.
            InputDev = New DirectInput.Device(instance.InstanceGuid)
            'Just pick the first one
            Exit For
        Next instance

        If (Nothing Is InputDev) Then
            MessageBox.Show("Unable to create a joystick device. Sample will exit.", "No joystick found")
            Return False
        End If

        InputDev.SetDataFormat(DeviceDataFormat.Joystick)
        InputDev.SetCooperativeLevel(Me, CooperativeLevelFlags.Exclusive Or CooperativeLevelFlags.Foreground)

        Dim d As DeviceObjectInstance

        For Each d In InputDev.Objects
            If 0 <> (d.ObjectId And CInt(DeviceObjectTypeFlags.Axis)) Then
                InputDev.Properties.SetRange(ParameterHow.ById, d.ObjectId, New InputRange(-1000, +1000))
            End If
        Next d

        Return True
    End Function

    Private Sub GetData()
        ' Make sure there is a valid device.
        If Nothing Is InputDev Then
            Debug.WriteLine("inputdev is nothing")
            Return
        End If
        Try
            ' Poll the device for info.
            InputDev.Poll()
        Catch inputex As InputException
            If TypeOf inputex Is NotAcquiredException Or TypeOf inputex Is InputLostException Then
                ' Check to see if either the app
                ' needs to acquire the device, or
                ' if the app lost the device to another
                ' process.
                Try
                    ' Acquire the device.
                    InputDev.Acquire()
                Catch
                    ' Failed to acquire the device.
                    ' This could be because the app
                    ' doesn't have focus.
                    Debug.WriteLine("Failed to acquire the device.")
                    Return
                End Try
            End If
        End Try
        'catch(InputException inputex)
        ' Get the state of the device.
        Try
            state = InputDev.CurrentJoystickState
            ' Catch any exceptions. None will be handled here, 
            ' any device re-aquisition will be handled above.  
        Catch
            Debug.WriteLine("error")
            Return
        End Try
        MoveModel()
    End Sub 'GetData

    Private Sub MoveModel()
        Dim buttons As Byte() = state.GetButtons()
        Dim ButtonFlag(buttons.Length) As Boolean
        Dim b As Byte
        Dim button As Integer = 0
        For Each b In buttons
            ButtonFlag(button) = False
            If b <> 0 Then
                ButtonFlag(button) = True
            End If
            button += 1
        Next

        meshPlane.ForwardVector = New Vector3(0.0F, 0.0F, 0.0F)

        If ButtonFlag(0) AndAlso ButtonFlag(1) Then
            'meshPlane.ForwardVector = New Vector3(0.0F, 0.0F, 0.0F)
        ElseIf ButtonFlag(0) Then
            'meshPlane.ForwardVector = New Vector3(0.0F, 0.0F, 0.1F)
            meshPlane.Accel()
        ElseIf ButtonFlag(2) Then
            'meshPlane.ForwardVector = New Vector3(0.0F, 0.0F, -0.1F)
            meshPlane.Brake()
        ElseIf ButtonFlag(1) Then
            'meshPlane.ForwardVector = New Vector3(0.0F, 0.0F, -0.1F)
            meshPlane.Back()
        Else
            meshPlane.AccelFree()
        End If
        'Debug.WriteLine("move")
        meshPlane.Move()
    End Sub

    Public Sub OnResetDevice(ByVal sender As Object, ByVal e As EventArgs)
        Dim materials As ExtendedMaterial() = Nothing

        Dim dev As Direct3D.Device = CType(sender, Direct3D.Device)

        dev.RenderState.ZBufferEnable = True
        dev.RenderState.Lighting = True
        dev.RenderState.Ambient = System.Drawing.Color.White
        dev.RenderState.CullMode = Cull.CounterClockwise
        dev.RenderState.FogEnable = True
        dev.RenderState.FogColor = Color.SkyBlue
        dev.RenderState.FogStart = 100.0F
        dev.RenderState.FogEnd = 150.0F
        dev.RenderState.FogVertexMode = FogMode.Linear

        meshPlane.loadMesh(dev, "fighter.x")
    End Sub

    Private Sub SetMatrices()
        Dim angle As Single = Environment.TickCount / 1000.0F
        Dim mt As Matrix
        'dev.Transform.World = Matrix.RotationY(Environment.TickCount / 1500.0F)
        'mt = Matrix.Translation(0.0F, 0.0F, 0.1F)
        'mt = Matrix.Multiply(mt, Matrix.RotationZ(Math.Sin(angle)))
        'meshPlane.Matrix = Matrix.Multiply(mt, Matrix.RotationY(Math.Sin(angle) / 3))

        'mt = Matrix.RotationZ(-Math.PI / 3)
        'mt = Matrix.Multiply(mt, Matrix.RotationY(-angle + 135))
        'mt = Matrix.Multiply(mt, Matrix.Translation(3.0F * Math.Cos(angle), 0.0F, 3.0F * Math.Sin(angle)))
        'meshPlane.Matrix = mt
        dev.Transform.View = Matrix.LookAtLH(New Vector3(0.0F, 2.0F, -2.0F), _
                                            meshPlane.Position, _
                                            New Vector3(0.0F, 1.0F, 0.0F))
        dev.Transform.Projection = Matrix.PerspectiveFovLH(Math.PI / 4, 1.0F, 0.01F, 1000.0F)
    End Sub

    Private Sub SetLights()
        Dim material As Material
        material.Ambient = Color.White
        material.Diffuse = Color.White

        dev.Material = material
        dev.Lights(0).Type = LightType.Directional
        dev.Lights(0).Diffuse = System.Drawing.Color.White
        dev.Lights(0).Direction = New Vector3(CSng(Math.Cos((Environment.TickCount / 250.0F))), -1.0F, CSng(Math.Sin((Environment.TickCount / 250.0F))))

        dev.Lights(0).Commit()
        dev.Lights(0).Enabled = True
        dev.RenderState.Ambient = System.Drawing.Color.FromArgb(&H202020)
    End Sub

    Private Sub Render()
        If IsNothing(dev) Then
            Return
        End If

        dev.Clear(ClearFlags.Target Or ClearFlags.ZBuffer, Color.Blue, 1.0F, 0)
        dev.BeginScene()
        SetLights()
        SetMatrices()

        meshPlane.DrawModel(dev)
        dev.EndScene()
        dev.Present()

    End Sub

    Shared Sub Main()
        Dim frm As Form1
        frm = New Form1()
        frm.InitializeGraphics()
        frm.InitDirectInput()
        frm.Show()

        While frm.Created
            frm.GetData()
            frm.Render()
            Application.DoEvents()
        End While
    End Sub

    Protected Overrides Sub OnMouseDown(ByVal e As System.Windows.Forms.MouseEventArgs)
        IsMouseDown = False
        MousePoint.X = e.X
        MousePoint.Y = e.Y
    End Sub

    Protected Overrides Sub OnMouseUp(ByVal e As System.Windows.Forms.MouseEventArgs)
        IsMouseDown = False
    End Sub

    Protected Overrides Sub OnMouseMove(ByVal e As System.Windows.Forms.MouseEventArgs)
        Dim deltaX, deltaY As Integer
        Dim mt As Matrix
        Static angleX, angleY As Single
        If IsMouseDown Then
            deltaX = -(e.X - MousePoint.X)
            deltaY = -(e.Y - MousePoint.Y)
            MousePoint.X = e.X
            MousePoint.Y = e.Y
            angleX += deltaX
            angleY += deltaY
            mt = Matrix.Multiply(Matrix.RotationZ(angleY / PixelPerRadianY), Matrix.RotationY(angleX / PixelPerRadianX))
            meshPlane.Matrix = mt
        End If
    End Sub

    Protected Overrides Sub OnPaint(ByVal e As System.Windows.Forms.PaintEventArgs)
        Render()
    End Sub
End Class
